/*
  Name: HTTP Server 2.4
  Copyright: 2007
  Original Author: Graillat Amaury
  Contribution:
  Date: 22/03/08
  Description: It's a simple server HTTP.
  License: CC-by-nc-sa
  File:  main.cpp


    This source is distributed with CC-by-nc-sa license.

    ENVIRONMENT:
     GCC + Win32 (with Code::Block)
     Lib : -lws2_32 -lgdi32
     Compression: UPX
*/

#error Please read the licence

///NOTE: -lws2_32 -lgdi32 -s
///NOTE: Avant une nouvelle version : remplacer toutes mes occurences de 2.6 en 2.6...
///TODO: / correction orthographique et traduction
///TODO: On peut empcher trop de connexion simultans pour la mme IP.
///TODO: Restructuration du code : faire des includes!!! : penser a extern ???
///http://chgi.developpez.com/windows/trayicon/

#define IDI_ICON1 6559
#define IDI_ICON2 6339
#define WM_TRAY_ICONE 6449

#define _WIN32_WINNT 0x0501 // Pour utiliser MEMORYSTATUSEX
#include <fstream>
#include <windows.h>
#include <string>
#include <iostream>
#include <stdio.h>
#include "Shlwapi.h"
#include <winsock2.h>
#include <csignal>
#include <shlobj.h> //boite de dialogue dossier.

///cout << __LINE__ << endl;

using namespace std;

////////////////////////////////////////////////////////////////////////////////
//                      D E C L A R A T I O N S                               //
////////////////////////////////////////////////////////////////////////////////
//Connection:
int sinsize;
SOCKET sock;
SOCKADDR_IN sin;
SOCKET csock;
SOCKADDR_IN csin;

//Varibles du serveur:
int port;  //Port a couter
WSADATA WSAData;    //On cr une instance socket

int timeout; //60s = 1 minute
BOOL turnOn; //Is the serveur turning on?
int defaudPacket=256; //Taille des paquets en envoi. => mme taille que char byteSend[256];
int sommeil; //Waiting for processor waiting
int listing=0; //Can it lists directories?
int script=0;  //Execute scripts
int max_client=1;
char defaudPath[512];
CRITICAL_SECTION cs;
int php; //1: le module php est prsent.

int FRANCAIS = 0;

//Threads menager
int threadTerminated();
int threadStarted();
int banned(char ip[21]);

//static
HWND objet[20] = { NULL }; //handles of objets
HWND fenetrePrincipale;
#define Dport "80"

//Clients:
volatile long totalClient;

//New client
int addClient();
DWORD WINAPI task_startServ(LPVOID lpParam);
DWORD WINAPI thread_client(LPVOID lpParam);

//Server
int initServ(int port);
int startServ();
int stopServ();

//Window and display
#define ID_B_TURNON 1
#define ID_B_STOP 2
#define ID_BR_SCRIPT 3
#define ID_BR_LIST 4
#define ID_B_PATH 12
NOTIFYICONDATA TrayIcon;

//Displaying
int addEvent(char event [1024]);
int error(char *error);
int display(int param);
int GetConfig();
void translate();

ofstream log("httpServ.log",ios::app);

////////////////////////////////////////////////////////////////////////////////
//                        S A V E      P A R A M :                            //
////////////////////////////////////////////////////////////////////////////////

void saveParam()
{
    ofstream fileParam("config.ini");

    char textEdit[512];
    GetWindowText(objet[7], textEdit, 10);
    fileParam << "timeout " << textEdit << endl;
    GetWindowText(objet[10], textEdit, 10);
    fileParam << "sommeil " << textEdit << endl;
    GetWindowText(objet[4],textEdit,100);
    fileParam << "defaud path " << textEdit << endl;
    GetWindowText(objet[11],textEdit,10);
    fileParam << "port " << textEdit << endl;
    GetWindowText(objet[6],textEdit, 10);
    fileParam << "max clients " << textEdit << endl;

    if (SendMessage(objet[13], BM_GETCHECK, 0, 0) == BST_CHECKED) fileParam << "list forbidden true" << endl;
    else fileParam << "list forbidden false" << endl;

    if (SendMessage(objet[16], BM_GETCHECK, 0, 0) == BST_CHECKED) fileParam << "scripts true" << endl;
    else fileParam << "scripts false" << endl;
    if(FRANCAIS) fileParam << "language FR" << endl;
    else  fileParam << "language EN" << endl;

    return;
}

void loadParam()
{
    ifstream fileParam("config.ini");
    if (!fileParam)
    {
        if (MessageBox(fenetrePrincipale, "Use this software in French language? Mettre ce logiciel en franais?", "amoweb HTTP Server", MB_YESNO|MB_ICONQUESTION) == IDYES)
        {
            FRANCAIS = 1;
        }
        return;
    }

    string line;

    while (getline(fileParam, line ) )
    {
        string paramName;
        string val;

        //line = tolower(line);
        if (line.find("timeout ") == 0)
        {
            val = line.substr(8, line.length()-7);
            SetWindowText(objet[7], val.c_str());
        }
        else if (line.find("sommeil ") == 0)
        {
            val = line.substr(8, line.length());
            SetWindowText(objet[10], val.c_str());
        }
        else if (line.find("defaud path ") == 0)
        {
            val = line.substr(12, line.length());
            SetWindowText(objet[4], val.c_str());
            strcpy(defaudPath, val.c_str());
        }
        else if (line.find("port ") == 0)
        {
            val = line.substr(5, line.length());
            SetWindowText(objet[11], val.c_str());
        }
        else if (line.find("max clients ") == 0)
        {
            val = line.substr(12, line.length());
            SetWindowText(objet[6], val.c_str());
        }
        else if (line.find("list forbidden true") == 0)
        {
            listing = true;
        }
        else if (line.find("list forbidden false") == 0)
        {
            listing = false;
        }
        else if (line.find("scripts true") == 0)
        {
            script = true;
        }
        else if (line.find("scripts false") == 0)
        {
            script = false;
        }
        else if (line.find("language FR") == 0)
        {
            FRANCAIS = true;
        }
        else if (line.find("language EN") == 0)
        {
            FRANCAIS = false;
        }
    }

    fileParam.close();

    return;
}

////////////////////////////////////////////////////////////////////////////////
//                     P R O G R A M   F A U L T :                            //
////////////////////////////////////////////////////////////////////////////////

//Sauvegarde les parametres avant boggage:
void saveFault(int param)
{
    cout << "An error occurred, the software will try to restore itself. I hope it will work!" << endl;

    saveParam();
    WSACleanup();
    log.close();

    char exe[512];
    char command[1024];
    GetModuleFileName(0, exe, 255);

    snprintf(command, sizeof(command), "\"%s\" -restore", exe);

    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );

    CreateProcess( NULL,command,NULL,NULL,FALSE,0,NULL,NULL,&si, &pi );

    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );

    exit(1);
}

//restore la dernire instance:
void restoreFault()
{
    startServ(); //start the server
}


////////////////////////////////////////////////////////////////////////////////
//                         C l i e n t   C L A S S                            //
////////////////////////////////////////////////////////////////////////////////
class Client
{
private:
    SOCKET csocket;
    int num_client;

    char ip[21];

    //Reprise des dl
    long range;
    long rangeTo;

    char fileToSend[1024];
    char file[1024];

    char paramPHP[2048];

public:

    //Destructeur:
    ~Client();

    //Constructeur:
    Client(SOCKET csocketT, char ipT[21]);

    //It close the connection with the client
    int closeConnection();

    //Does this file exist:
    int fileExists(char* fileCheck);

    //It Send a file
    //param: file name (char file)
    //return: TRUE if the file can be open
    int sendFile(char* file);

    //Parse php script
    int sendPhpFile(char* file, string param);

    //Execute BAT script
    int sendBatFile(char* file, string param);

    //Send the headers:
    //Param: 0 don't Send the \r\n
    //       2 for a partiel contant
    int sendHeaders(int last);

    //Send the mime type:
    int sendHeaders(char* filename);

    //Function managing the client:
    int clientManager();

    //Reads client's messages:
    //return:   it return the filename
    char *readClient();

    //Send the list of file:
    //param: the path
    int sendList(char* path);

    //URL decoding
    void urlDecode(char *dest, const char *src);
};

////////////////////////////////////////////////////////////////////////////////
//                    C L A S S    F O N C T I O N S                          //
////////////////////////////////////////////////////////////////////////////////

Client::~Client()
{
    threadTerminated();
}

Client::Client(SOCKET csocketT, char ipT[21])
        : csocket(csocketT), range(0), rangeTo(0)
{
    signal(SIGSEGV, saveFault);
    signal(SIGFPE, saveFault);
    signal(SIGILL, saveFault);

    strcpy(ip, ipT);
    threadStarted();

    clientManager();

    //Destruction de l'objet:
    delete this;
}

int Client::closeConnection()
{
    closesocket(csocket);
    return 0;
}

int Client::fileExists(char* fileCheck)
{
    WIN32_FIND_DATA FindData;
    HANDLE eFind;
    eFind=FindFirstFile(fileCheck, &FindData);
    if (eFind != INVALID_HANDLE_VALUE) return 1;
    FindClose(eFind);
    return 0;
}


int Client::sendFile(char* file)
{
    int sizeOfByteSend = 258;
    char *byteSend = new char[sizeOfByteSend];

    strcpy(byteSend,"");

    ifstream mfile;

    //Read the file:
    mfile.open(file, ios::in | ios::binary);

    //Calculate size of file:
    long sizeFile;
    mfile.seekg(0,ios_base::end);
    sizeFile = mfile.tellg();
    mfile.seekg(0,ios_base::beg);

    //Does this file exist?
    if (!mfile.fail())
    {
        //cout << "range=" << range << endl << "rangeTo" << rangeTo << endl;

        //Partial content:
        if (range != -1 && range < sizeFile)
        {
            //Send headers for partiel contant:
            sendHeaders(2);

            //Send the mime type:
            sendHeaders(file);

            snprintf(byteSend,sizeOfByteSend,"Content-Range: bytes %ld-%ld/%ld\r\n", range, sizeFile, sizeFile);
            send(csocket, byteSend, strlen(byteSend), 0);

            //Send the size of the file:
            snprintf(byteSend,sizeOfByteSend,"Content-Length: %ld\r\n\r\n", sizeFile-range);
            send(csocket, byteSend, strlen(byteSend), 0);

            //Change the position in file:
            mfile.seekg(range);
        }
        else
        {
            //Send headers for simple downloading:
            sendHeaders(0);
            //Send the mime type:
            sendHeaders(file);

            //Send the size of the file:
            snprintf(byteSend,sizeOfByteSend,"Content-Length: %ld\r\n\r\n", sizeFile);
            send(csocket, byteSend,strlen( byteSend), 0);
        }

        //Calcule la taille  envoyer:
        int remain = sizeFile;

        //Taille de chaques paquets  envoyer:
        int sizeToSend = 256;

        while (turnOn)
        {
            //Fin du fichier:
            if (mfile.eof()) break;

            //Reset the char:
            strcpy(byteSend,"");

            //Read part of file:
            mfile.read(byteSend, sizeToSend);

            //Il rest moins de 255 bytes:
            if (remain < sizeToSend) sizeToSend = remain;

            //Combien il reste?
            remain=remain-sizeToSend;

            //Rend la non bloquante:
            u_long arg = 1;
            ioctlsocket(csocket, FIONBIO, &arg);

            int time=clock();

            //Send the file : care about the time out..
            while(turnOn)
            {
                if(send(csocket, byteSend, sizeToSend, 0) == sizeToSend) break;

                //UC saving...  (in any case it isn't hurried...)
                Sleep(1);

                if(clock() - time > timeout*1000)
                {
                    mfile.clear();
                    mfile.close();

                    delete byteSend;
                    return 1;
                }
            }

        }

        //On ferme le fichier:
        mfile.clear();
        mfile.close();

        //Indique la fin du fichier:
        strcpy(byteSend,"\r\n\r\n");
        send(csocket, byteSend, sizeToSend, 0);
    }
    else  //Le fichier n'existe pas:
    {
        //On ferme le fichier:
        mfile.clear();
        mfile.close();

        delete byteSend;
        return -1;
    }

    delete byteSend;
    return 1;
}

int Client::sendBatFile(char* file, string param)
{
    if (!script) return 0;

    int randomTime = clock();
    char commandePHP[3000];
    char ouputBat[128];

    //Replace the ASCII with printable characteres
    char *paramChr = new char[param.length()+1];
    strcpy(paramChr, param.c_str()+1);
    //hexaToASCII(paramChr);
    urlDecode(paramChr, paramChr);
    param = paramChr;
    delete paramChr;

    //Create the filename:
    sprintf(ouputBat, "BATtemp%d.htm", randomTime);

    sprintf(commandePHP, "@cmd /C %s \"%s\" > %s", file, param.c_str(), ouputBat);
    system(commandePHP);

    sendFile(ouputBat);

    DeleteFile(ouputBat);

    error(strerror(errno));

    return 0;
}

int Client::sendPhpFile(char* file, string param)
{
    int randomTime = clock();
    char filePHP[128];
    char commandePHP[3000];

    //Replace the ASCII with printable characteres
    char *paramChr = new char[param.length()+1];
    strcpy(paramChr, param.c_str());
    //hexaToASCII(paramChr);
    urlDecode(paramChr, paramChr);
    param = paramChr;
    delete paramChr;

    //Create the filename:
    sprintf(filePHP, "PHPtemp%d.htm", randomTime);

    //Add the PHP bridge ;)
    char fileMod[1030];
    snprintf(fileMod, sizeof(fileMod), "%s-%d.php", file, randomTime);

    ofstream fileToMod(fileMod,ios::out);

    fileToMod << "<?php /// Author : Amaury Graillat" << endl;
    fileToMod << "// On recherche la chane entre ? et = :" << endl;
    fileToMod << "$argument = explode(\"&\", $argv[1]);" << endl;
    fileToMod << "$seek = 0;" << endl;
    fileToMod << "while($argument[$seek] != null)" << endl;
    fileToMod << "{";
    fileToMod << "	// on oublie le ? qui sert  rien:" << endl;
    fileToMod << "	if($seek == 0) $posStart = 1;" << endl;
    fileToMod << "	else $posStart = 0;" << endl;
    fileToMod << "	// On prends jusqu'au \"=\":" << endl;
    fileToMod << "	$posStop = strpos($argument[$seek], \"=\");" << endl;
    fileToMod << "	// On rcupre le nom du paramtre" << endl;
    fileToMod << "	if($seek == 0) $name = substr($argument[$seek], $posStart, $posStop-2+$posStart);" << endl;
    fileToMod << "	else $name = substr($argument[$seek], $posStart, $posStop+$posStart);" << endl;
    fileToMod << "	//if($seek == 0) $posStart = $posStop +1;" << endl;
    fileToMod << "	$posStart = $posStop+1;" << endl;
    fileToMod << "	//else  $posStart = $posStop;" << endl;
    fileToMod << " 	$param = substr($argument[$seek], $posStart, strlen($argument[$seek]));" << endl;
    fileToMod << "	$_POST[$name] = $param;" << endl;
    fileToMod << "	$_GET[$name] = $param;" << endl;
    fileToMod << " 	$HTTP_POST_VARS[$name] = $param;" << endl;
    fileToMod << "	$HTTP_GET_VARS[$name] = $param;" << endl;
    fileToMod << "	$seek++;" << endl;
    fileToMod << "}" << endl;
    fileToMod << "?>" << endl;

    ifstream filePHPto(file);

    string ligne;
    while (getline(filePHPto, ligne))
    {
        fileToMod << ligne << endl;
    }

    fileToMod.close();
    filePHPto.close();

    sprintf(commandePHP, "@php\\php-cgi.exe -f \"%s\" \"%s\" > %s", fileMod, param.c_str(), filePHP);
    system(commandePHP);

    sendFile(filePHP);

    DeleteFile(filePHP);
    DeleteFile(fileMod);

    error(strerror(errno));

    return 0;
}


int Client::sendHeaders(char* filename)
{
    char ext[7];
    char mime[64];

    strncpy(ext, strrchr(filename, '.'), sizeof(ext));

    if (!strlen(ext)) return 0;

    if (!strcmp(ext, ".asf"))        strcpy(mime, "video/x-ms-asf");
    else if (!strcmp(ext, ".asf"))   strcpy(mime, "video/x-ms-asf");
    else if (!strcmp(ext, ".asx"))   strcpy(mime, "video/x-ms-asf");
    else if (!strcmp(ext, ".avi"))   strcpy(mime, "video/x-msvideo");
    else if (!strcmp(ext, ".bin"))   strcpy(mime, "application/octet-stream");
    else if (!strcmp(ext, ".bmp"))   strcpy(mime, "image/bmp");
    else if (!strcmp(ext, ".bz2"))   strcpy(mime, "application/x-bzip2");
    else if (!strcmp(ext, ".class")) strcpy(mime, "application/octet-stream");
    else if (!strcmp(ext, ".css"))   strcpy(mime, "text/css");
    else if (!strcmp(ext, ".doc"))   strcpy(mime, "application/msword");
    else if (!strcmp(ext, ".dvi"))   strcpy(mime, "application/x-dvi");
    else if (!strcmp(ext, ".eps"))   strcpy(mime, "application/postscript");
    else if (!strcmp(ext, ".exe"))   strcpy(mime, "application/octet-stream");
    else if (!strcmp(ext, ".gif"))   strcpy(mime, "image/gif");
    else if (!strcmp(ext, ".gz"))    strcpy(mime, "application/x-gzip");
    else if (!strcmp(ext, ".htm"))   strcpy(mime, "text/html");
    else if (!strcmp(ext, ".html"))  strcpy(mime, "text/html");
    else if (!strcmp(ext, ".php"))   strcpy(mime, "text/html");
    else if (!strcmp(ext, ".bat"))   strcpy(mime, "text/html");
    else if (!strcmp(ext, ".jar"))   strcpy(mime, "application/octet-stream");
    else if (!strcmp(ext, ".jpeg"))  strcpy(mime, "image/jpeg");
    else if (!strcmp(ext, ".jpg"))   strcpy(mime, "image/jpeg");
    else if (!strcmp(ext, ".js"))    strcpy(mime, "application/x-javascript");
    else if (!strcmp(ext, ".mov"))   strcpy(mime, "video/quicktime");
    else if (!strcmp(ext, ".mp2"))   strcpy(mime, "audio/mpeg");
    else if (!strcmp(ext, ".mp3"))   strcpy(mime, "audio/mpeg");
    else if (!strcmp(ext, ".mpeg"))  strcpy(mime, "video/mpeg");
    else if (!strcmp(ext, ".mpg"))   strcpy(mime, "video/mpeg");
    else if (!strcmp(ext, ".pdf"))   strcpy(mime, "application/pdf");
    else if (!strcmp(ext, ".rtf"))   strcpy(mime, "application/rtf");
    else if (!strcmp(ext, ".sgm"))   strcpy(mime, "text/x-sgml");
    else if (!strcmp(ext, ".sgml"))  strcpy(mime, "text/x-sgml");
    else if (!strcmp(ext, ".swf"))   strcpy(mime, "application/x-shockwave-flash");
    else if (!strcmp(ext, ".tar"))   strcpy(mime, "application/x-tar");
    else if (!strcmp(ext, ".tex"))   strcpy(mime, "application/x-tex");
    else if (!strcmp(ext, ".tgz"))   strcpy(mime, "application/x-tar");
    else if (!strcmp(ext, ".txt"))   strcpy(mime, "text/plain");
    else if (!strcmp(ext, ".wav"))   strcpy(mime, "audio/x-wav");
    else if (!strcmp(ext, ".xls"))   strcpy(mime, "application/x-excel");
    else if (!strcmp(ext, ".xml"))   strcpy(mime, "text/xml");
    else if (!strcmp(ext, ".xsl"))   strcpy(mime, "text/xsl");
    else if (!strcmp(ext, ".zip"))   strcpy(mime, "application/zip");
    else return 0;

    char byteSend[128];
    snprintf(byteSend,sizeof(byteSend),"Content-Type: %s\r\n", mime);
    send(csocket, byteSend, strlen(byteSend), 0);

    return 0;
}

int Client::sendHeaders(int last)
{
    string byteSend;
    byteSend = "";

    //Send headers:
    //Partial content:
    if (last==2)
    {
        byteSend="HTTP/1.1 206 Partial content\r\n";
        send(csocket, byteSend.c_str(),byteSend.length(), 0);
    }

    //It's a simple download:
    else
    {
        byteSend="HTTP/1.1 200 OK\r\n";
        send(csocket, byteSend.c_str(),byteSend.length(), 0);
    }

    //Send the name of the server:
    byteSend="Server: amoweb HTTP Server 2.6\r\n";
    send(csocket, byteSend.c_str(),byteSend.length(), 0);

    return 0;
}


int Client::clientManager()
{
    char message[1024];
    int sizeOfByteSend=256;
    char *byteSend = new char[sizeOfByteSend];
    memset(byteSend,0,sizeof(byteSend));

    //Read the name of file:
    strncpy(fileToSend, readClient(), sizeOfByteSend);

    //Send the file except if "-1" :
    if (!strcmp(fileToSend, "-0"))
    {
        snprintf(message, sizeof(message), "%s : The server is down", ip);
        addEvent(message);
        closeConnection();
        delete byteSend;
        return 0;
    }
    else if (!strcmp(fileToSend, "-1"))
    {
        //Write in console:
        snprintf(message, sizeof(message), "%s : TimeOut", ip);
        addEvent(message);

        closeConnection();
        delete byteSend;
        return 0;
    }
    else if (!strcmp(fileToSend, "-2"))
    {
        //Write in console:
        snprintf(message, sizeof(message), "%s : /!\\ Buffer Overflow", ip);
        banned(ip);
        addEvent(message);
        closeConnection();
        delete byteSend;
        return 0;
    }

    //Write event list:
    snprintf(message, sizeof(message), "%s : %s",ip,fileToSend);
    addEvent(message);

    //A file is requested:
    if (fileExists(fileToSend))
    {
        //PHP File:
        char ext[5];

        if (strrchr(fileToSend, '.') != 0)
        {
            strcpy(ext, strrchr(fileToSend, '.'));

            //PHP file
            if (!strcmp(".php",ext) || !strcmp(".ph3",ext) || !strcmp(".ph4",ext) || !strcmp(".php4",ext))
            {
                sendPhpFile(fileToSend, paramPHP);
            }
            //Batch file:
            if (!strcmp(".bat", ext) && script)
            {
                sendBatFile(fileToSend, paramPHP);
            }
            //Non-script files:
            else
            {
                sendFile(fileToSend);
            }
        }

        closeConnection();
        delete byteSend;
        return 0;
    }
    //A directory is requested:
    else if ((GetFileAttributes(fileToSend) & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
    {
        //This variable contains the directory + index.(htm(l) / php)
        char* fileIndex = new char[strlen(fileToSend)+10];
        strcpy(fileIndex, fileToSend);

        //Remove the /
        if (fileToSend[ strlen(fileToSend)-1 ] == *"/") fileToSend[ strlen(fileToSend)-1 ] = 0;

        //index.htm does exist?
        snprintf(fileIndex, strlen(fileToSend)+11, "%s/index.htm", fileToSend);
        if (fileExists(fileIndex))
        {
            sendFile(fileIndex);

            closeConnection();
            delete byteSend;
            delete fileIndex;
            return 0;
        }
        //Does index.html exist?
        snprintf(fileIndex, strlen(fileToSend)+11, "%s/index.html", fileToSend);
        if (fileExists(fileIndex))
        {
            sendFile(fileIndex);

            closeConnection();
            delete byteSend;
            delete fileIndex;
            return 0;
        }
        //Does index.php exist?
        snprintf(fileIndex, strlen(fileToSend)+11, "%s/index.php", fileToSend);
        if (fileExists(fileIndex))
        {
            //Parse & send the php file:
            if (strlen(fileIndex) < 1024) sendPhpFile(fileIndex, "");

            closeConnection();
            delete byteSend;
            delete fileIndex;
            return 0;
        }
        //Lists the directory:
        else
        {
            send(csocket, "\r\n",2, 0);
            sendList(fileToSend);
            closeConnection();
            delete byteSend;
            //delete fileIndex;      <-------------- why?
            return 0;
        }
    }
    else
    {
        send(csocket, "\r\n",2, 0);

        //Superbe message d'erreur a la apache
        strcpy(byteSend,"<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>The requested URL ");
        send(csocket, byteSend,strlen( byteSend), 0);
        strncpy(byteSend, fileToSend,256);
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend," was not found on this server.</p> <hr>");
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend,"<address> amoweb HTTP Server 2.6</address></body></html>");
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend,"\r\n");
        send(csocket, byteSend,strlen( byteSend), 0);

        closeConnection();
        delete byteSend;
        return 0;
    }


    delete byteSend;
    return 0;
}

char* Client::readClient()
{
    char *bufferStr = new char[4096];
    string buffer;

    //Reset the char:
    memset(file,0,sizeof(file));
    strcpy(bufferStr, "");
    memset(paramPHP,0,sizeof(paramPHP));

    //Non-bloking socket:
    u_long arg = 1;
    ioctlsocket(csocket, FIONBIO, &arg);

    //Read the connexion and manage the time out
    int time=clock();

    while (strlen(bufferStr) < 1) //While the client have sent nothing
    {
        //Read command:
        int Nbyte = EAGAIN;
        while (Nbyte == EAGAIN)
        {
            Nbyte = recv(csocket, bufferStr, 4095, 0);
        }

        bufferStr[Nbyte] = *"\0";

        //ioctlsocket(csock, FIONBIO, &argp);
        //error = recv(csock, bufferRecv, sizeof(bufferRecv)-1, 0)

        //Time out:
        if (clock() - time > timeout*1000)
        {
            delete bufferStr;
            return "-1";
        }

        //The server is down:
        if (turnOn==0)
        {
            delete bufferStr;
            return "-0";
        }

        //It waits 5 ms:
        Sleep(sommeil);
    }

    //On copie dans le string:
    buffer = bufferStr;

    //Remove headers:
    int whereStart;
    int whereEnd;

    int post = 1;
    whereStart = buffer.find("POST /") + 5;

    if (whereStart-5==-1)
    {
        whereStart = buffer.find("GET /") + 4;
        post = 0;
    }

    whereEnd = buffer.find(" HTTP");

    //Evite le depassement de tampon:
    if ((unsigned) whereEnd - (unsigned)whereStart > sizeof(file))
    {
        delete bufferStr;
        return "-2";
    }

    //On recupre le nom:
    string fileT=buffer.substr(whereStart, whereEnd-whereStart);

    //Evite le depassement de tampon:
    strncpy(file,fileT.c_str(), sizeof(file));

    //hexaToASCII(file);
    urlDecode(file, file);

    //Return index.htm by defaut:
    if (strlen(file)<1 || !strcmp(file,"/"))
        strcpy(file,"/");

    //Reprise des tlchargements:
    //Remove headers:
    whereStart = buffer.find("Range: bytes=");

    //cout << "whereStart=" << whereStart << endl;

    if (whereStart != -1)
    {
        whereEnd = buffer.find("-");
        if (whereEnd < whereStart+13)
        {
            //On remplace le - qui n'est pas le bon pour ne pas l'avoir
            // dans la prochaine recherche: en esprant que l'on ne va pas
            // s'en servir '(
            buffer.replace(whereEnd,1," ");
        }

        //On rcupre le nombre:
        string rangeStr=buffer.substr(whereStart+13, whereEnd-(whereStart + 13));
        range = atoi(rangeStr.c_str());

        whereStart = whereEnd;
        whereEnd = buffer.find("\r");
        rangeStr = buffer.substr(whereStart, whereEnd);
        rangeTo = atoi(rangeStr.c_str());
    }
    else
    {
        range = -1;
        rangeTo = -1;
    }

    //Rcupre les paramtres PHP:
    if (strstr(file, "?"))
    {
        // On rcupre les paramtres PHP:
        strncpy(paramPHP, strchr(file, '?'), sizeof(paramPHP));

        // On coupe la chaine file avant le ? :
        file[strlen(file) - strlen(paramPHP)] = *"\0";
    }
    else
    {
        strcpy(paramPHP, "");
    }

    char *fileTemp = new char[sizeof(file)];

    if (file[0] == *"/" || file[0] == *"\\")
    {
        snprintf(fileTemp, sizeof(file), "%s%s", defaudPath, file);
    }
    else
    {
        snprintf(fileTemp, sizeof(file), "%s\\%s", defaudPath, file);
    }

    strcpy(file, fileTemp);

    // Paramtres PHP POST:
    if (post)
    {
        strcpy(bufferStr, strrchr(bufferStr, '\n'));
        strcpy(bufferStr, bufferStr+1);

        //Si on a pas un caractre vide:
        if (isprint(bufferStr[1]))
        {
            if (strlen(paramPHP)) strncat(paramPHP,"&", sizeof(paramPHP));
            else strncat(paramPHP,"?", sizeof(paramPHP));

            strncat(paramPHP, bufferStr , sizeof(paramPHP));
        }
        else
        {
            strncat(paramPHP,"\0", sizeof(paramPHP));
        }
    }

    //Return the file name:
    delete fileTemp;
    delete bufferStr;

    return file;

} //End of readConnection()

int Client::sendList(char* path)
{
    int sizeOfByteSend=512;
    char *byteSend = new char[sizeOfByteSend];
    strcpy(byteSend,"");

    if (listing==0)
    {
        //Superbe message d'erreur  la apache
        strcpy(byteSend,"<html><head><title>403 Forbidden</title></head><body><h1>Forbidden</h1><p>The requested URL ");
        send(csocket, byteSend,strlen( byteSend), 0);
        strncpy(byteSend,path,sizeof(path));
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend," is Forbidden.</p> <hr>");
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend,"<address> amoweb HTTP Server 2.6</address></body></html>");
        send(csocket, byteSend,strlen( byteSend), 0);
        strcpy(byteSend,"\r\n");
        send(csocket, byteSend,strlen( byteSend), 0);

        delete byteSend;
        return 0;
    }

    HANDLE hFind;
    WIN32_FIND_DATA FindData;

    strcpy(byteSend, "<html><head></head><body><b>LIST OF FILES:</b><br>");
    send(csocket, byteSend,strlen( byteSend), 0);

    //Keep only the folder for seek in:
    char where[512];
    strncpy(where,path,512);
    if (strlen(path)>1) //In other folder:
    {
        snprintf(where,sizeof(where), "%s\\*", where);
    }
    else //In root:
    {
        strcpy(where, "*");
    }

    //Begin seeking:
    hFind=FindFirstFile(where, &FindData);
    if (hFind!=INVALID_HANDLE_VALUE)
    {
        //If it's a file:
        if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
        {
            snprintf(byteSend,sizeOfByteSend,"<br><a href=\"%s\">%s</a>",FindData.cFileName,FindData.cFileName);
            send(csocket, byteSend,strlen( byteSend), 0);
        }
        else
        {
            snprintf(byteSend,sizeOfByteSend,"<br><a href=\"%s/\">%s</a>",FindData.cFileName,FindData.cFileName);
            send(csocket, byteSend,strlen( byteSend), 0);
        }


        // Next files:
        while (FindNextFile (hFind, &FindData))
        {
            if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
            {
                snprintf(byteSend,sizeOfByteSend,"<br><a href=\"%s\">%s</a>",FindData.cFileName, FindData.cFileName);
                send(csocket, byteSend,strlen( byteSend), 0);
            }
            else
            {
                snprintf(byteSend,sizeOfByteSend,"<br><a href=\"%s/\">%s</a>",FindData.cFileName,FindData.cFileName);
                send(csocket, byteSend,strlen( byteSend), 0);
            }

        }
    }
    // Fin de la recherche
    FindClose (hFind);

    strcpy(byteSend, "</body></html>");
    send(csocket, byteSend,strlen( byteSend), 0);

    delete byteSend;

    return 0;
} //End of sendList()

/// ///// /////// ///////// /////////// //////// /////// //////// ///////
///              ERREUR ICI ? enfin je pense...
/// ///// /////// ///////// /////////// //////// /////// //////// ///////

void Client::urlDecode(char *dest, const char *src)
{
    // ascii = strtoul(code, &end, 16);
    // *dest++ = (char)ascii;

    // /*
    const char *p = src;
    char code[3] = {0};
    unsigned long ascii = 0;
    char *end = NULL;

    while (*p)
    {
        if (*p == '%')
        {
            memcpy(code, ++p, 2);
            ascii = strtoul(code, &end, 16);
            *dest++ = (char)ascii;
            p += 2;
        }
        else *dest++ = *p++;
    }
    *dest = '\0';

    // */
}

////////////////////////////////////////////////////////////////////////////////
//                   T H R E A D        M E N A G E R                         //
////////////////////////////////////////////////////////////////////////////////

int banned(char ip[21])
{
    ifstream fichierBl("blacklist.txt");
    if (!fichierBl)
    {
        ofstream fileCr( "blacklist.txt" );

        if(FRANCAIS)
        {
            fileCr << "Please  a bannir du serveur (une adresse par ligne):\n";
        }
        else
        {
            fileCr << "Please enter IP adresses to banish (only one by ligne):\n";
        }

        fileCr << "\n";

        fileCr.close();
        return 0;
    }

    string ligne;

    while (getline( fichierBl, ligne ) )
    {
        if (!strcmp(ligne.c_str(), ip)) return 1;
    }

    fichierBl.close();

    return 0;
}

//Le thread se termine:
int threadTerminated()
{
    totalClient--;
    return 0;
}

//Total threads:
int threadTotal()
{
    return totalClient;
}

//Le thread a dmarr:
int threadStarted()
{
    totalClient++;
    return 0;
}

////////////////////////////////////////////////////////////////////////////////
//                      N E W        C L I E N T S                            //
////////////////////////////////////////////////////////////////////////////////

//Creates the new threads:
int addClient()
{
    signal(SIGSEGV, saveFault);
    signal(SIGFPE, saveFault);
    signal(SIGILL, saveFault);

    char message[1024];
    DWORD ThreadId;

    while (turnOn==1)
    {
        //Mise a jour de l'affichage de la RAM:
        display(turnOn);

        int sinsize = sizeof(csin);

        while (turnOn == 1)
        {
            while (threadTotal() == max_client)
            {
                if (turnOn==0)
                    break;
                Sleep(sommeil);
            }

            if ((csock = accept(sock, (SOCKADDR *)&csin, &sinsize)) != INVALID_SOCKET
                    && threadTotal() <= max_client)
            {
                cout << "New client" << endl;
                if (banned(inet_ntoa(sin.sin_addr)))
                {
                    snprintf(message, sizeof(message), "IP black-listed : %s", inet_ntoa(sin.sin_addr));
                    addEvent(message);

                    break;
                }

                if(FRANCAIS)
                {
                    snprintf(message, sizeof(message), "Nouveau Client : %s", inet_ntoa(sin.sin_addr));
                }
                else
                {
                    snprintf(message, sizeof(message), "New Client : %s", inet_ntoa(sin.sin_addr));
                }

                addEvent(message);

                CreateThread(NULL,0,thread_client,NULL,0,&ThreadId);
                break;
            }
        }

        //On attend 5 ms:
        Sleep(sommeil);
        }

    return 0;
}

DWORD WINAPI thread_client(LPVOID lpParam)
{
    signal(SIGSEGV, saveFault);
    signal(SIGFPE, saveFault);
    signal(SIGILL, saveFault);

    new Client(csock, inet_ntoa(sin.sin_addr));
    return 0;
}

//Thread for menage the server;
DWORD WINAPI task_startServ(LPVOID lpParam)
{
    if(FRANCAIS) addEvent("Serveur demarr");
    else addEvent("Server started");

    initServ(port);

    addClient();
    return 0;
}

////////////////////////////////////////////////////////////////////////////////
//                              S E R V E U R                                 //
////////////////////////////////////////////////////////////////////////////////

//Init the server:
int initServ(int port)
{
    //Open the connection:
    WSADATA WSAData;
    WSAStartup(MAKEWORD(2,0), &WSAData);
    sock = socket(AF_INET, SOCK_STREAM, 0);
    sin.sin_addr.s_addr   = INADDR_ANY;
    sin.sin_family    = AF_INET;
    sin.sin_port    = htons(port);
    bind(sock, (SOCKADDR *)&sin, sizeof(sin));
    listen(sock, 1024);

    if (sock==INVALID_SOCKET)
    {
        if(FRANCAIS)
        {
            addEvent(">Une erreur s'est produite lors de");
            addEvent("l'ouverture de la socket: vrifiez que");
            addEvent("le port n'est pas dja utilis, et les");
            addEvent("paramtre du parefeu.");
        }
        else
        {
            addEvent(">An error occured when the");
            addEvent("socket was opening the port.");
            addEvent("Please Check if the port isn\'t");
            addEvent("already used");
        }
    }

    return 0;
}


//Start the server:
int startServ()
{
    //Get the config:
    if (!GetConfig()) return 0;
    EnableWindow(objet[1],0);

    if(FRANCAIS) SetWindowText(objet[2], "Arrter");
    else SetWindowText(objet[2], "Stop");

    EnableWindow(objet[2],1);

    EnableWindow(objet[3],0);
    EnableWindow(objet[4],0);
    EnableWindow(objet[5],0);
    EnableWindow(objet[6],0);
    EnableWindow(objet[7],0);
    EnableWindow(objet[8],0);
    EnableWindow(objet[9],0);
    EnableWindow(objet[10],0);
    EnableWindow(objet[11],0);
    EnableWindow(objet[12],0);
    EnableWindow(objet[13],0);
    EnableWindow(objet[16],0);

    turnOn=1;

    DWORD ThreadId;

    //Create the thread:
    CreateThread(NULL,0,task_startServ,NULL,0,&ThreadId);

    return 1;
}

//Stop the server:
int stopServ()
{
    saveParam();

    turnOn=0;

    //Close the server:
    WSACleanup();

    int time = clock();
    while (threadTotal())
    {
        display(turnOn);

        if (clock()-time > 3000)
        {
            if(FRANCAIS) addEvent("Erreur lors de la fermeture des threads. L'application a t ferme.");
            else addEvent("Error the thread can't be stopped. Server was been stopped.");

            log.close();

            //force la femeture du programme:
            DWORD processId;
            HANDLE hProcess;
            GetWindowThreadProcessId(fenetrePrincipale,&processId);
            hProcess = OpenProcess(PROCESS_TERMINATE,false,processId);
            if (hProcess)
            {
                TerminateProcess(hProcess,0);
                CloseHandle(hProcess);
            }
            exit(1); // Au cas o ;)
        }

        Sleep(10);
    }

    //On remet  1 pour eviter les dpassements
    max_client=1;

    EnableWindow(objet[1],1);
    EnableWindow(objet[2],0);
    EnableWindow(objet[3],1);
    EnableWindow(objet[4],1);
    EnableWindow(objet[5],1);
    EnableWindow(objet[6],1);
    EnableWindow(objet[7],1);
    EnableWindow(objet[8],1);
    EnableWindow(objet[9],1);
    EnableWindow(objet[10],1);
    EnableWindow(objet[11],1);
    EnableWindow(objet[12],1);
    EnableWindow(objet[13],1);
    EnableWindow(objet[16],1);

    if(FRANCAIS) addEvent("Serveur arrt");
    else addEvent("Serveur stopped");
    addEvent("");
    return 0;
}

////////////////////////////////////////////////////////////////////////////////
//          F O N C T I O N S        D ' A F F I C H A G E                    //
////////////////////////////////////////////////////////////////////////////////

//Translates software:
void translate()
{
    if(!FRANCAIS)
    {
        SetWindowText(objet[13], "Folder Listing forbidden");
        SetWindowText(objet[16], "Execute .bat scripts");
        SetWindowText(objet[ 9], "Sleep (ms):");
        SetWindowText(objet[ 3], "Path:");
        SetWindowText(objet[ 1], "Start");
        SetWindowText(objet[ 2], "ReadMe");
    }
}

//Display differents info : RAM, swap, users... :
int display(int param)
{
    char title[128];
    MEMORYSTATUS oMS;
    GlobalMemoryStatus(&oMS);
    int threadUse = threadTotal();

    if (param) //Serveur started?
    {
        threadTotal();
        if(FRANCAIS) snprintf(title,128, " RAM: %ld%% utilis   -   %d / %d",oMS.dwMemoryLoad,threadUse,max_client);
        else  snprintf(title,128, " RAM: %ld%% used   -   %d / %d",oMS.dwMemoryLoad,threadUse,max_client);
    }
    else
    {
        if(FRANCAIS) snprintf(title,128, " RAM: %ld%% utilis   -   Serveur Arrt", oMS.dwMemoryLoad);
        else  snprintf(title,128, " RAM: %ld%% used   -   Server Stopped", oMS.dwMemoryLoad);
    }

    SetWindowText(objet[15], title);

    error(strerror(errno));

    return 0;
}

//Rcupre la config:
int GetConfig()
{
    char textEdit[512];

    //TimeOut:
    GetWindowText(objet[7], textEdit, 10);
    timeout = atoi(textEdit);

    if (timeout < 2)
    {
        if(FRANCAIS)
        {
            addEvent(">Le time out est trop bas, des clients");
            addEvent("risquent d\'tre dconnects.");
        }
        else
        {
            addEvent(">Time Out is too low. Clients can");
            addEvent("be disconnected.");
        }
        addEvent("");
    }


    //Sommeil
    GetWindowText(objet[10], textEdit, 10);
    sommeil = atoi(textEdit);

    if (sommeil == 0)
    {
        if(FRANCAIS)
        {
            addEvent(">Le temps de sommeil est trs court cela");
            addEvent("permet une meilleure ractivit utilisez");
            addEvent("un chiffre plus grand pour conomiser le");
            addEvent("processeur.");
        }
        else
        {
            addEvent(">The sleep time is very short that allow");
            addEvent("a better reactivity, use a larger time");
            addEvent("to save the CPU.");
        }
        addEvent("");
    }

    if (sommeil > 500)
    {
        if(FRANCAIS)
        {
            addEvent(">Le temps de sommeil est trs long les");
            addEvent("performances peuvent tre dgrades.");
        }
        else
        {
            addEvent(">The sleep time is too larger performance");
            addEvent("can be degraded.");
        }
        addEvent("");
    }

    //Defaud Path:
    //GetWindowText(objet[4],textEdit,100);
    if (!strlen(defaudPath))
    {
        if(FRANCAIS) addEvent(">Dossier non valide ou non accessible.");
        else  addEvent(">Folder invalid or not accessible");
        addEvent("");

        return 0;
    }

    if (defaudPath[strlen(defaudPath)-1] == *"\\" || defaudPath[strlen(defaudPath)-1] == *"/")
        defaudPath[strlen(defaudPath)-1] = *"\0";

    //Port:
    GetWindowText(objet[11],textEdit,10);
    port = atoi(textEdit);

    if (port > 65535 && port < 1)
    {
        if(FRANCAIS) addEvent(">Le port n\'est pas valide.");
        else  addEvent(">Invalid port.");
        addEvent("");
        return 0;
    }

    //Max Clients:
    GetWindowText(objet[6],textEdit, 10);
    max_client = atoi(textEdit);

    if (max_client == 1)
        max_client = 2;
    else if (max_client == 0)
    {
        if(FRANCAIS) addEvent(">Il faut au minimum un client");
        else  addEvent(">One client is needed at least");
        addEvent("");
        return 0;
    }

    //Forbid to list repertoires:
    if (SendMessage(objet[13], BM_GETCHECK, 0, 0) == BST_CHECKED)
    {
        listing=0;
    }
    else
    {
        listing=1;
    }

    //Allow to execute scripts:
    if (SendMessage(objet[16], BM_GETCHECK, 0, 0) == BST_CHECKED)
    {
        script=1;
    }
    else
    {
        script=0;
    }

    // PHP module
    WIN32_FIND_DATA FindData;
    HANDLE PHPfind;
    PHPfind=FindFirstFile("php\\php-cgi.exe", &FindData);
    if (PHPfind == INVALID_HANDLE_VALUE)
    {
        if(FRANCAIS)
        {
            addEvent(">Module PHP non prsent: ");
            addEvent(" php\\php-cgi.exe ");
            addEvent(" Les fonctions PHP serons dsactivs.");
        }
        else
        {
            addEvent(">PHP was not found: ");
            addEvent(" php\\php-cgi.exe ");
            addEvent(" PHP won't be supported.");
        }

        php=0;
    }
    else
    {
        php=1;
    }
    FindClose(PHPfind);

    return 1;
}

int error(char *error)
{
    time_t  DateHeure;
    time(&DateHeure);

    char message[1024];

    strncpy(message, error, sizeof(message));

    if (strcmp("No error", message) && strcmp("Result too large", message))
    {
        addEvent(message);
        log << ctime(&DateHeure) <<  "   " << message << "   " << endl;
    }

    return 0;
}

//Add a new event to list:
int addEvent(char event [1024])
{
    time_t  DateHeure;
    time(&DateHeure);

    if (!strcmp(event, "upList"))
    {
        SendMessage(objet[14], LB_SETCURSEL, 0, 0);
        return 0;
    }

    if (strlen(event)!=0) log << ctime(&DateHeure) << "   " << event << endl;

    SendMessage(objet[14], LB_ADDSTRING, 0, (LONG)event);

    //On se place a chaques fois  la fin:
    int nbline = SendMessage(objet[14], LB_GETCOUNT, 0, 0);
    SendMessage(objet[14], LB_SETCURSEL, nbline-1, nbline);

    return 0;
}

////////////////////////////////////////////////////////////////////////////////
//             G E S T I O N   D E   L A   F E N E T R E                      //
////////////////////////////////////////////////////////////////////////////////
HINSTANCE hInst;
LRESULT CALLBACK procedureFenetrePrincipale(HWND, UINT, WPARAM, LPARAM);
int WinMain (HINSTANCE cetteInstance, HINSTANCE precedenteInstance,
             LPSTR lignesDeCommande, int modeDAffichage)
{
    signal(SIGSEGV, saveFault);
    signal(SIGFPE, saveFault);
    signal(SIGILL, saveFault);

    MSG message;
    WNDCLASS classeFenetre;

    hInst = cetteInstance;

    classeFenetre.style = 0;
    classeFenetre.lpfnWndProc = procedureFenetrePrincipale;
    classeFenetre.cbClsExtra = 0;
    classeFenetre.cbWndExtra = 0;
    classeFenetre.hInstance = NULL;
    classeFenetre.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    classeFenetre.hCursor = LoadCursor(NULL, IDC_ARROW);
    classeFenetre.hbrBackground = (HBRUSH)(1+COLOR_BTNFACE);
    classeFenetre.lpszMenuName =  NULL;
    classeFenetre.lpszClassName = "classeF";

    // On prvoit quand mme le cas o a choue
    if (!RegisterClass(&classeFenetre))
        return FALSE;

    fenetrePrincipale = CreateWindow("classeF", "HTTP Server 2.6 - Amaury Graillat",
                                     WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 450, 255, NULL, NULL,
                                     cetteInstance, NULL);

    if (!fenetrePrincipale)
        return FALSE;

    ShowWindow(fenetrePrincipale, modeDAffichage);
    UpdateWindow(fenetrePrincipale);

    if (!strcmp(lignesDeCommande, "-restore"))
    {
        restoreFault();
        if(FRANCAIS) addEvent("Le serveur a t redemarr avec succs!");
        else  addEvent("Server was started successful!");
    }


    while (GetMessage(&message, NULL, 0, 0))
    {
        // For change focus when TAB push
        // use with the style WS_TABSTOP
        if (!IsDialogMessage(fenetrePrincipale, &message))
        {
            TranslateMessage(&message);
            DispatchMessage(&message);
        }
    }
    return message.wParam;
}

LRESULT CALLBACK procedureFenetrePrincipale(HWND fenetrePrincipale, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
    case WM_CREATE:
        HFONT hfont0 = CreateFont(-11, 0, 0, 0, 400, FALSE, FALSE, FALSE, 1, 400, 0, 0, 0, "MS Shell Dlg 2");

        objet[1] = CreateWindowEx(0, "Button", "Lancer", WS_VISIBLE | WS_CHILD | WS_TABSTOP, 11, 11, 113, 23, fenetrePrincipale, (HMENU)ID_B_TURNON, hInst, 0);
        SendMessage(objet[1], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[2] = CreateWindowEx(0, "Button", "A Lire", WS_VISIBLE | WS_CHILD | WS_TABSTOP, 129, 11, 51, 23, fenetrePrincipale, (HMENU)ID_B_STOP, hInst, 0);
        SendMessage(objet[2], WM_SETFONT, (WPARAM)hfont0, FALSE);
        EnableWindow(objet[2],1);

        objet[3] = CreateWindowEx(0, "Static", "Chemin :", WS_VISIBLE | WS_CHILD | WS_GROUP, 16, 42, 45, 13, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[3], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[4] = CreateWindowEx(0, "Button", "c:\\", WS_VISIBLE | BS_LEFT | WS_CHILD | WS_TABSTOP, 68, 37, 113, 23, fenetrePrincipale, (HMENU)ID_B_PATH, hInst, 0);
        SendMessage(objet[4], WM_SETFONT, (WPARAM)hfont0, FALSE);
        EnableWindow(objet[4],1);

        objet[5] = CreateWindowEx(0, "Static", "Max.Client:", WS_VISIBLE | WS_CHILD | WS_GROUP, 16, 68, 68, 13, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[5], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[6] = CreateWindowEx(0, "Edit", 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER | ES_AUTOHSCROLL | ES_NUMBER, 91, 62, 90, 23, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[6], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[7] = CreateWindowEx(0, "Edit", 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER | ES_AUTOHSCROLL | ES_NUMBER, 91, 86, 90, 23, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[7], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[8] = CreateWindowEx(0, "Static", "TimeOut (s):", WS_VISIBLE | WS_CHILD | WS_GROUP, 16, 91, 68, 13, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[8], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[9] = CreateWindowEx(0, "Static", "Sommeil (ms):", WS_VISIBLE | WS_CHILD | WS_GROUP, 16, 117, 68, 13, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[9], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[10] = CreateWindowEx(0, "Edit", 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER | ES_AUTOHSCROLL | ES_NUMBER, 91, 111, 90, 23, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[10], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[11] = CreateWindowEx(0, "Edit", 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER | ES_AUTOHSCROLL | ES_NUMBER, 115, 135, 66, 23, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[11], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[12] = CreateWindowEx(0, "Static", "Port:", WS_VISIBLE | WS_CHILD | WS_GROUP, 18, 141, 90, 13, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[12], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[13] = CreateWindowEx(WS_EX_TRANSPARENT, "Button", "Interdire le listage des dossiers", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_LEFTTEXT | BS_AUTOCHECKBOX, 15, 164, 166, 16, fenetrePrincipale, (HMENU)ID_BR_LIST, hInst, 0);
        SendMessage(objet[13], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[14] = CreateWindowEx(0, "ListBox", 0, WS_VISIBLE | WS_CHILD | WS_VSCROLL | WS_BORDER | LBS_NOINTEGRALHEIGHT, 191, 11, 240, 171, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[14], WM_SETFONT, (WPARAM)hfont0, FALSE);

        //Affichage de la RAM et du fichier d'echange:
        objet[15] = CreateWindowEx(0, "Static", "         :::L:A:N:C:E:M:E:N:T:::", WS_VISIBLE | WS_CHILD | WS_GROUP, 16, 187, 500, 16, fenetrePrincipale, 0, hInst, 0);
        SendMessage(objet[15], WM_SETFONT, (WPARAM)hfont0, FALSE);

        objet[16] = CreateWindowEx(WS_EX_TRANSPARENT, "Button", "Executer les scripts .bat", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_LEFTTEXT | BS_AUTOCHECKBOX, 15, 184, 166, 16, fenetrePrincipale, (HMENU)ID_BR_SCRIPT, hInst, 0);
        SendMessage(objet[16], WM_SETFONT, (WPARAM)hfont0, FALSE);

        //PARAMETRES PAR DEFAUT:
        //Port:
        SetWindowText(objet[11], Dport);

        //TimeOut:
        SetWindowText(objet[7], "5");

        //Sommeil:
        SetWindowText(objet[10], "5");

        //Defaud Path:
        SetWindowText(objet[4],"c:\\");

        //Max Clients:
        SetWindowText(objet[6],"30");

        loadParam();
        if (script) CheckDlgButton(fenetrePrincipale, ID_BR_SCRIPT, BST_CHECKED);
        if (listing) CheckDlgButton(fenetrePrincipale, ID_BR_LIST, BST_CHECKED);

        translate();

        return 0;

        //Dynamique size:
    case WM_SIZE:
        MoveWindow(objet[14], 190, 11, LOWORD(lParam)-190-7, HIWORD(lParam)-11-14, TRUE);
        MoveWindow(objet[15], 11, HIWORD(lParam)-13, 500, HIWORD(lParam)-11-12, TRUE);
        if (HIWORD(lParam) < 215) MoveWindow(objet[15], 500, 500, 0, 0, TRUE);
        if (LOWORD(lParam) < 350) MoveWindow(objet[15], 500, 500, 0, 0, TRUE);
        break;

    case WM_COMMAND:
        display(turnOn);

        switch (LOWORD(wParam))
        {
        case ID_B_TURNON:

            if (!startServ()) break;

            display(turnOn);

            break;

        case ID_BR_SCRIPT:
            if (SendMessage(objet[16], BM_GETCHECK, 0, 0) == BST_CHECKED)
            {
                char messageB[512];
                if(FRANCAIS) strcpy(messageB, "Vous avez choisis d\'activer l\'excution des scripts \".bat\"  distance.\nCette fonction doit tre utilise seulement si vous savez exactement ce que vous tes entrain de faire.\n   Continuer?");
                else strcpy(messageB, "You choose execute .bat scripts.\nThis function must be only used if you know exactly what you are doing!\n   continue?");

                if (MessageBox(fenetrePrincipale, messageB, "amoweb HTTP Server", MB_OKCANCEL|MB_ICONEXCLAMATION) == IDOK)
                {
                    CheckDlgButton(fenetrePrincipale, ID_BR_SCRIPT, BST_CHECKED);
                }
                else
                {
                    CheckDlgButton(fenetrePrincipale, ID_BR_SCRIPT, BST_UNCHECKED);
                }
            }
            break;
        case ID_B_PATH:
            char szDir[260];
            char newPath[512];

            BROWSEINFO bi;
            memset(&bi, 0, sizeof(BROWSEINFO));
            bi.hwndOwner = fenetrePrincipale;
            bi.pidlRoot = NULL;
            bi.pszDisplayName = szDir;
            bi.lpszTitle =  "HTTP Server";

            LPITEMIDLIST pItem = SHBrowseForFolder(&bi);
            if (pItem)
            {
                SHGetPathFromIDList(pItem, newPath);
                LPMALLOC lpMalloc;
                SHGetMalloc(&lpMalloc);
                lpMalloc->Free(pItem);
            }

            //Vrifi c'est un rpertoire valide:
            if (strlen(newPath) > 1)
            {
                strcpy(defaudPath, newPath);
                SetWindowText(objet[4],defaudPath);
            }

            break;

        case ID_B_STOP:
            if (turnOn == 1)
            {
                timeout = 0;
                display(turnOn);
                stopServ();

                break;
            }

            if(FRANCAIS)
            {
                addEvent(" /!\\ LA LECTURE DU 3. EST OLIGATOIRE");
                addEvent("1. Paramtres simples:");
                addEvent("");
                addEvent("  Chemin: Chemin vers le dossier par dfaut.");
                addEvent("");
                addEvent("  Max Client: Nombre de client simultans. ");
                addEvent("      (Le dbit est divis par le nombre  ");
                addEvent("      de client.)");
                addEvent("");
                addEvent("  Port: Port d\'coute du serveur. Si vous ne");
                addEvent("      savez pas: laissez le par dfaut.");
                addEvent("");
                addEvent("  Interdire le listage des dossiers: Si vous ne souhaitez");
                addEvent("      pas utiliser votre serveur comme un dossier.");
                addEvent("");
                addEvent("2. Paramtres avanc:");
                addEvent("  Time Out: Temps Maximum d\'inactivit du client.");
                addEvent("");
                addEvent("  Sommeil: Ce paramtre est a laisser par dfaut.");
                addEvent("     Il s'agis du temps d'attente du serveur");
                addEvent("     Entre chaque vrifications des nouveaux");
                addEvent("     client.");
                addEvent("");
                addEvent("  Excuter les scripts .bat:");
                addEvent("     Cette fonction permet de lancer des scripts");
                addEvent("     .bat a distance. Ils permettent par exemple");
                addEvent("     de commander l'extenction du serveur ou");
                addEvent("     ou le lancement d'un programme...");
                addEvent("     Cette fonction est a activer seulement si vous");
                addEvent("     vous savez ce que vous faites. Elle peut");
                addEvent("     permettre l'excution de programmes malveillant.");
                addEvent("     Utiliser @echo off au dbut du script pour viter");
                addEvent("     l'affichage des commandes.");
                addEvent("     Utiliser le caractre ? Ou la commande POST pour");
                addEvent("     passer des paramtres a votre script rcuprs par");
                addEvent("     %0 %1 %2...");
                addEvent("");
                addEvent("3. LICENCE:");
                addEvent("  Ce logiciel est sous licence CC-by-nc-sa.");
                addEvent("     Cette licence est disponible sur creativecommons.org.");
                addEvent("     Pour plus d'informations contactez l'auteur.");
                addEvent("   a. Vous tes libres:");
                addEvent("        -de reproduire, distribuer et communiquer cette cration au public");
                addEvent("        -de modifier cette cration");
                addEvent("   b. Selon les conditions suivantes:");
                addEvent("        -Paternit. Vous devez citer le nom de l'auteur original de la manire");
                addEvent("         indique par l'auteur de l'oeuvre ou le titulaire des droits qui vous");
                addEvent("         confre cette autorisation (mais pas d'une manire qui suggrerait");
                addEvent("         qu'ils vous soutiennent ou approuvent votre utilisation de l'oeuvre).");
                addEvent("        -Pas d'Utilisation Commerciale. Vous n'avez pas le droit d'utiliser");
                addEvent("         cette cration  des fins commerciales.");
                addEvent("        -Partage des Conditions Initiales  l'Identique: Si vous modifiez,");
                addEvent("         transformez ou adaptez cette cration, vous n'avez le droit de");
                addEvent("         distribuer la cration qui en rsulte que sous un contrat identique");
                addEvent("          celui-ci.");
                addEvent("   c. A chaque rutilisation ou distribution de cette cration, vous devez");
                addEvent("      faire apparatre clairement au public les conditions contractuelles de");
                addEvent("      sa mise  disposition.");
                addEvent("      Chacune de ces conditions peut tre leve si vous obtenez l'autorisation");
                addEvent("      du titulaire des droits sur cette oeuvre.");
                addEvent("      Rien dans ce contrat ne diminue ou ne restreint le droit moral de l'auteur");
                addEvent("      ou des auteurs.");
                addEvent("");
            }
            else
            {
                addEvent("/!\\ YOU MUST READ 3.");
                addEvent("1. Simples options:");
                addEvent("");
                addEvent("  Path: Default path.");
                addEvent("");
                addEvent("  Max Client: Maximum number of simultaneous clients. ");
                addEvent("      (Debit is divided between all clients)");
                addEvent("");
                addEvent("  Port: Port to listen new clients. If you do not know what that means,");
                addEvent("        leave that alone.");
                addEvent("  Folder Listing forbidden: If you dont want to use your server same a folder. ");
                addEvent("");
                addEvent("2. Advanced options:");
                addEvent("  Time out: Maximum of client time inactivity time. ");
                addEvent("");
                addEvent("  Sleep: Clamp-on between each verification of new client. Leave default value.");
                addEvent("");
                addEvent("  Execute .bat scripts:");
                addEvent("     This function allows executing .bat scripts: ");
                addEvent("     It can, for instance, lunch a program or shutdown");
                addEvent("     the server. This function must be only used if you");
                addEvent("     know exactly what you are doing. It could let virus");
                addEvent("     executing.");
                addEvent("Use @echo off to avoid commands displaying.");
                addEvent("    Use ? characters, or POST command to passing a");
                addEvent("     parameter. %0, %1, %2 in .bat to get prams. ");
                addEvent("");
                addEvent("3. LICENCE:");
                addEvent("  This software is licensed CC-by-nc-sa.");
                addEvent("     You can read this licence to creativecommons.org.");
                addEvent("     For more information please contact author.  ");
                addEvent("   ");
                addEvent("You are free:");
                addEvent("     -To Share  to copy, distribute and transmit this software.");
                addEvent("     -To Remix  to adapt the work.");
                addEvent("");
                addEvent("Under the following conditions:");
                addEvent("        -Attribution. You must attribute the work in the manner");
                addEvent(" specified by the author or licensor (but not in any way that suggests that they");
                addEvent(" endorse you or your use of the work");
                addEvent("        - Non-commercial. You may not use this work for commercial purposes.");
                addEvent("");
                addEvent("For any reuse or distribution, you must make clear to others the license terms");
                addEvent(" of this work. The best way to do this is with a link to this web page.");
                addEvent("Any of the above conditions can be waived if you get permission from the copyright holder.");
                addEvent("Nothing in this license impairs or restricts the author's moral rights.");
            }

            addEvent("upList");

            break;
        }
        return 0;

    case WM_TRAY_ICONE:

        if(lParam == WM_RBUTTONUP)
        {

        }

        if(lParam == WM_LBUTTONUP)
        {
             ShowWindow(fenetrePrincipale,SW_SHOW);
             Shell_NotifyIcon(NIM_DELETE,&TrayIcon);
        }
        return 0;

    case WM_SYSCOMMAND:
        if(wParam == SC_MINIMIZE)
        {
            ShowWindow(fenetrePrincipale,SW_HIDE);
            TrayIcon.cbSize = sizeof( NOTIFYICONDATA );
            TrayIcon.hWnd = fenetrePrincipale;
            TrayIcon.uID = 0;

            //Color icon
            if(turnOn) TrayIcon.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON2));
            //N&B icon
            else TrayIcon.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));

            TrayIcon.uCallbackMessage = WM_TRAY_ICONE;
            TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
            strcpy(TrayIcon.szTip, "amoweb HTTP Server");
            Shell_NotifyIcon(NIM_ADD,&TrayIcon);
            return 0;
        }
        else return DefWindowProc(fenetrePrincipale, message, wParam, lParam);

        ///
        // http://msdn2.microsoft.com/en-us/library/ms646360(VS.85).aspx
        ///

    case WM_CLOSE:
        char messageB[10];
        if(FRANCAIS) strcpy(messageB, "Quitter ?");
        else strcpy(messageB, "Quit?");

        if (MessageBox(fenetrePrincipale, messageB, "amoweb HTTP Server", MB_YESNO|MB_ICONQUESTION) == IDYES)
        {
            saveParam();
            log.close();
            PostQuitMessage(1);
        }
        else
        {
            ShowWindow(fenetrePrincipale,SW_HIDE);
            TrayIcon.cbSize = sizeof( NOTIFYICONDATA );
            TrayIcon.hWnd = fenetrePrincipale;
            TrayIcon.uID = 0;

            //Color icon
            if(turnOn) TrayIcon.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON2));
            //N&B icon
            else TrayIcon.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));

            TrayIcon.uCallbackMessage = WM_TRAY_ICONE;
            TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
            strcpy(TrayIcon.szTip, "amoweb HTTP Server");
            Shell_NotifyIcon(NIM_ADD,&TrayIcon);
        }

        return 0;

    case WM_DESTROY:

        saveParam();
        log.close();
        PostQuitMessage(1);
        return 0;

    default:
        return DefWindowProc(fenetrePrincipale, message, wParam, lParam);
    }
    return 0;
}
